﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.Integration;
using System.Drawing.Text;
using System.Drawing.Imaging;


namespace Speak_To_Text_new_Style
{



    public partial class Form1 : Form
    {
        string currentFileName = "";

        private RTBSpellCheck rtb = new RTBSpellCheck();

        public Form1()
        {
            InitializeComponent();
            this.Controls.Add(rtb.ElementHost);
            currentFile = "";
            
        }

        private void Document_LinkClicked(object sender, LinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start(e.LinkText);
        }


        private void GetFontCollection()
        {
            InstalledFontCollection InsFonts = new InstalledFontCollection();

            foreach (FontFamily item in InsFonts.Families)
            {
                comboBoxItem1.Items.Add(item.Name);
            }
            comboBoxItem1.SelectedIndex = 0;
        }

        private void PopulateFontSizes()
        {
            for (int i = 1; i <= 75; i++)
            {
                comboBoxItem2.Items.Add(i);
            }

            comboBoxItem2.SelectedIndex = 11;
        }


        private void TextEditor_Load(object sender, EventArgs e)
        {
            FontSize();




        }

        private void buttonItem20_Click(object sender, EventArgs e)
        {
            Form LatestNews = new Form2();
            LatestNews.Show(this);
        }

        private void Neu_Click(object sender, EventArgs e)
        {
            try
            {
                if (richTextBox1.Modified == true)
                {
                    System.Windows.Forms.DialogResult answer;
                    answer = MessageBox.Show("Save current document before creating new document?", "Unsaved Document", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (answer == System.Windows.Forms.DialogResult.No)
                    {
                        currentFile = "";
                        richTextBox1.Modified = false;
                        richTextBox1.Clear();
                        return;
                    }
                    else
                    {
                        buttonItem1_Click(this, new EventArgs());
                        richTextBox1.Modified = false;
                        richTextBox1.Clear();
                        currentFile = "";
                        return;
                    }
                }
                else
                {
                    currentFile = "";
                    richTextBox1.Modified = false;
                    richTextBox1.Clear();
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString(), "Error");
            }
        }

        private void buttonItem25_Click(object sender, EventArgs e)
        {

        }

        private void textBoxX1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.All;
            richTextBox1.Text = e.Data.GetData(DataFormats.Bitmap).ToString();
        }


        private void Form1_Load(object sender, EventArgs e)
        {

            var host = new ElementHost();
            var tb = new System.Windows.Controls.TextBox();
            host.Child = tb;
            host.Location = new Point(50, 50);
            host.Size = new Size(100, 20);
            this.Controls.Add(host);

            tb.SpellCheck.IsEnabled = true;
            host.Child = tb;

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void elementHost1_ChildChanged(object sender, ChildChangedEventArgs e)
        {

        }

        private void buttonItem62_Click(object sender, EventArgs e)
        {

        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {

        }

        private void buttonItem3_Click(object sender, EventArgs e)
        {

        }

        private void buttonItem40_Click(object sender, EventArgs e)
        {
            Font bfont = new Font(richTextBox1.Font, FontStyle.Bold);
            Font rfont = new Font(richTextBox1.Font, FontStyle.Regular);

            if (richTextBox1.SelectedText.Length == 0)
                return;
            if (richTextBox1.SelectionFont.Bold)
            {
                richTextBox1.SelectionFont = rfont;
            }
            else
            {
                richTextBox1.SelectionFont = bfont;
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (richTextBox1.Text.Length > 0)
            {
                toolStripStatusLabel1.Text = richTextBox1.Text.Length.ToString();
            }
        }

        private void buttonItem41_Click(object sender, EventArgs e)
        {
            Font Ifont = new Font(richTextBox1.Font, FontStyle.Italic);
            Font rfont = new Font(richTextBox1.Font, FontStyle.Regular);

            if (richTextBox1.SelectedText.Length == 0)
                return;
            if (richTextBox1.SelectionFont.Italic)
            {
                richTextBox1.SelectionFont = rfont;
            }
            else
            {
                richTextBox1.SelectionFont = Ifont;
            }
        }

        private void buttonItem42_Click(object sender, EventArgs e)
        {
            Font Ufont = new Font(richTextBox1.Font, FontStyle.Underline);
            Font rfont = new Font(richTextBox1.Font, FontStyle.Regular);

            if (richTextBox1.SelectedText.Length == 0)
                return;
            if (richTextBox1.SelectionFont.Underline)
            {
                richTextBox1.SelectionFont = rfont;
            }
            else
            {
                richTextBox1.SelectionFont = Ufont;
            }
        }

        private void buttonItem35_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Left;
        }

        private void buttonItem36_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Center;
        }

        private void buttonItem37_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Right;
        }



        private void tb_FontSize_SelectedIndexChanged(object sender, EventArgs e)
        {

            richTextBox1.SelectionFont = new Font(comboBoxItem1.SelectedItem.ToString(), int.Parse(comboBoxItem1.SelectedItem.ToString()), richTextBox1.SelectionFont.Style);
        }

        void FontSize()
        {
            for (int fntSize = 10; fntSize <= 75; fntSize++)

            {
                comboBoxItem2.Items.Add(fntSize.ToString());
            }


        }

        private void buttonItem21_Click(object sender, EventArgs e)
        {
            float NewFontSize = richTextBox1.SelectionFont.SizeInPoints + 2;

            Font NewSize = new Font(richTextBox1.SelectionFont.Name, NewFontSize, richTextBox1.SelectionFont.Style);

            richTextBox1.SelectionFont = NewSize;
        }

        private void buttonItem29_Click(object sender, EventArgs e)
        {
            float NewFontSize = richTextBox1.SelectionFont.SizeInPoints - 2;

            Font NewSize = new Font(richTextBox1.SelectionFont.Name, NewFontSize, richTextBox1.SelectionFont.Style);

            richTextBox1.SelectionFont = NewSize;
        }

        private void buttonItem4_Click(object sender, EventArgs e)
        {
            saveFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            saveFileDialog1.Filter = "RTF|.rtf";
            saveFileDialog1.Title = "Save";

            if (saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (saveFileDialog1.FileName.Length > 0)
                {
                    richTextBox1.SaveFile(saveFileDialog1.FileName, RichTextBoxStreamType.RichText);
                }
            }
        }

        private void buttonItem64_Click(object sender, EventArgs e)
        {

            saveFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            saveFileDialog1.Filter = "Text Files|*.txt|VB Files|*.vb|C# Files|*.cs|All Files|*.*";
            saveFileDialog1.Title = "Save As";

            if (saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (saveFileDialog1.FileName.Length > 0)
                {
                    richTextBox1.SaveFile(saveFileDialog1.FileName, RichTextBoxStreamType.PlainText);
                }
            }
        }

        private void buttonItem17_Click(object sender, EventArgs e)
        {
            richTextBox1.Undo();
        }

        private void buttonItem18_Click(object sender, EventArgs e)
        {
            richTextBox1.Redo();
        }

        private void buttonItem14_Click(object sender, EventArgs e)
        {
            richTextBox1.Cut();
        }

        private void buttonItem15_Click(object sender, EventArgs e)
        {
            richTextBox1.Copy();
        }

        private void buttonItem44_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectAll();
        }

        private void FontCollection()
        {
            InstalledFontCollection InsFonts = new InstalledFontCollection();

            foreach (FontFamily item in InsFonts.Families)
            {
                comboBoxItem1.Items.Add(item.Name);
            }
            comboBoxItem1.SelectedIndex = 0;
        }

        private void FontSizes()
        {
            for (int i = 1; i <= 75; i++)
            {
                comboBoxItem2.Items.Add(i);
            }

            comboBoxItem2.SelectedIndex = 11;
        }

        private void buttonItem28_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                richTextBox1.SelectionColor = colorDialog1.Color;
            }
        }

        private void ComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Font NewFont = new Font(comboBoxItem1.SelectedItem.ToString(), richTextBox1.SelectionFont.Size, richTextBox1.SelectionFont.Style);

            richTextBox1.SelectionFont = NewFont;
        }

        private void ComboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            float NewSize;

            float.TryParse(comboBoxItem2.SelectedItem.ToString(), out NewSize);

            Font NewFont = new Font(richTextBox1.SelectionFont.Name, NewSize, richTextBox1.SelectionFont.Style);

            richTextBox1.SelectionFont = NewFont;
        }

        private void buttonItem2_Click(object sender, EventArgs e)
        {
            richTextBox1.Paste();
        }

        private void buttonItem26_Click(object sender, EventArgs e)
        {
            Font Strikeout = new Font(richTextBox1.SelectionFont.FontFamily, richTextBox1.SelectionFont.SizeInPoints, FontStyle.Strikeout);
            Font RegularFont = new Font(richTextBox1.SelectionFont.FontFamily, richTextBox1.SelectionFont.SizeInPoints, FontStyle.Regular);

            if (richTextBox1.SelectionFont.Strikeout)
            {
                richTextBox1.SelectionFont = RegularFont;
            }
            else
            {
                richTextBox1.SelectionFont = Strikeout;
            }
        }

        private void buttonItem3_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Text File (.txt)|*.txt|All Files|*.*";
            ofd.ShowDialog();
            richTextBox1.Text = System.IO.File.ReadAllText(ofd.FileName);
        }

        private void buttonItem14_Click_1(object sender, EventArgs e)
        {
            richTextBox1.Cut();
        }

        private void buttonItem15_Click_1(object sender, EventArgs e)
        {
            richTextBox1.Copy();
        }

        private void buttonItem2_Click_1(object sender, EventArgs e)
        {
            richTextBox1.Paste();
        }

        private void buttonItem4_Click_1(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(currentFileName))
            {
                saveFileDialog1.Filter = "Text File (.txt)|*.txt|All Files|*.*";
                saveFileDialog1.ShowDialog();
            }
            else
            {
                using (System.IO.StreamWriter sw = new System.IO.StreamWriter(currentFileName))
                {
                    sw.Write(richTextBox1.Text);
                }
            }
        }

        private void buttonItem61_Click(object sender, EventArgs e)
        {
            saveFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            saveFileDialog1.Filter = "Text Files|*.txt|VB Files|*.vb|C# Files|*.cs|All Files|*.*";
            saveFileDialog1.Title = "Save As";

            if (saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (saveFileDialog1.FileName.Length > 0)
                {
                    richTextBox1.SaveFile(saveFileDialog1.FileName, RichTextBoxStreamType.PlainText);
                }
            }
        }

        private void buttonItem6_Click(object sender, EventArgs e)
        {
            PrintDialog printDialog1 = new PrintDialog();
            printDialog1.Document = printDocument1;
            DialogResult result = printDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                printDocument1.Print();

            }
        }

        private void buttonItem7_Click(object sender, EventArgs e)
        {
            try
            {
                if (richTextBox1.Modified == true)
                {
                    System.Windows.Forms.DialogResult answer;
                    answer = MessageBox.Show("Save this document before closing?", "Unsaved Document", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (answer == System.Windows.Forms.DialogResult.Yes)
                    {
                        if (string.IsNullOrEmpty(currentFileName))
                        {
                            saveFileDialog1.Filter = "Text File (.txt)|*.txt|All Files|*.*";
                            saveFileDialog1.ShowDialog();
                        }
                        else
                        {
                            using (System.IO.StreamWriter sw = new System.IO.StreamWriter(currentFileName))
                            {
                                sw.Write(richTextBox1.Text);
                            }
                        }
                    }
                    else
                    {
                        richTextBox1.Modified = false;
                        Application.Exit();
                    }
                }
                else
                {
                   richTextBox1.Modified = false;
                    Application.Exit();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString(), "Error");
            }
        }

        private void buttonItem39_Click(object sender, EventArgs e)
        {

        }

        private void buttonItem62_Click_1(object sender, EventArgs e)
        {
            Form1 newForm = new Form1();
            newForm.Show();
        }

        private void buttonItem17_Click_1(object sender, EventArgs e)
        {
            richTextBox1.Undo();
        }

        private void buttonItem18_Click_1(object sender, EventArgs e)
        {
            richTextBox1.Redo();
        }

        private void buttonItem44_Click_1(object sender, EventArgs e)
        {
            richTextBox1.SelectAll();
        }

        private void buttonItem28_Click_1(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                richTextBox1.SelectionColor = colorDialog1.Color;
            }
        }

        private void buttonItem40_Click_1(object sender, EventArgs e)
        {
            Font bfont = new Font(richTextBox1.Font, FontStyle.Bold);
            Font rfont = new Font(richTextBox1.Font, FontStyle.Regular);

            if (richTextBox1.SelectedText.Length == 0) ;

            if (richTextBox1.SelectionFont.Bold)
            {
                richTextBox1.SelectionFont = rfont;
            }
            else
            {
                richTextBox1.SelectionFont = bfont;
            }
        }

        private void buttonItem26_Click_1(object sender, EventArgs e)
        {
            Font Strikeout = new Font(richTextBox1.SelectionFont.FontFamily, richTextBox1.SelectionFont.SizeInPoints, FontStyle.Strikeout);
            Font RegularFont = new Font(richTextBox1.SelectionFont.FontFamily, richTextBox1.SelectionFont.SizeInPoints, FontStyle.Regular);

            if (richTextBox1.SelectionFont.Strikeout)
            {
                richTextBox1.SelectionFont = RegularFont;
            }
            else
            {
                richTextBox1.SelectionFont = Strikeout;
            }
        }

        private void buttonItem21_Click_1(object sender, EventArgs e)
        {
            float NewFontSize = richTextBox1.SelectionFont.SizeInPoints + 2;

            Font NewSize = new Font(richTextBox1.SelectionFont.Name, NewFontSize, richTextBox1.SelectionFont.Style);

            richTextBox1.SelectionFont = NewSize;
        }

        private void buttonItem29_Click_1(object sender, EventArgs e)
        {
            float NewFontSize = richTextBox1.SelectionFont.SizeInPoints - 2;

            Font NewSize = new Font(richTextBox1.SelectionFont.Name, NewFontSize, richTextBox1.SelectionFont.Style);

            richTextBox1.SelectionFont = NewSize;
        }

        private void buttonItem37_Click_1(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Right;
        }

        private void buttonItem36_Click_1(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Center;
        }

        private void buttonItem35_Click_1(object sender, EventArgs e)
        {
            richTextBox1.SelectionAlignment = HorizontalAlignment.Left;
        }

        private void buttonItem42_Click_1(object sender, EventArgs e)
        {
            Font Ufont = new Font(richTextBox1.Font, FontStyle.Underline);
            Font rfont = new Font(richTextBox1.Font, FontStyle.Regular);

            if (richTextBox1.SelectedText.Length == 0)
                ;
            if (richTextBox1.SelectionFont.Underline)
            {
                richTextBox1.SelectionFont = rfont;
            }
            else
            {
                richTextBox1.SelectionFont = Ufont;
            }
        }

        private void buttonItem41_Click_1(object sender, EventArgs e)
        {
            Font Ifont = new Font(richTextBox1.Font, FontStyle.Italic);
            Font rfont = new Font(richTextBox1.Font, FontStyle.Regular);

            if (richTextBox1.SelectedText.Length == 0) ;
            if (richTextBox1.SelectionFont.Italic)
            {
                richTextBox1.SelectionFont = rfont;
            }
            else
            {
                richTextBox1.SelectionFont = Ifont;
            }
        }

        private void buttonItem24_Click(object sender, EventArgs e)
        {
            try
            {
                if (richTextBox1.Modified == true)
                {
                    System.Windows.Forms.DialogResult answer;
                    answer = MessageBox.Show("Save current document before creating new document?", "Unsaved Document", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (answer == System.Windows.Forms.DialogResult.No)
                    {
                        currentFile = "";
                        richTextBox1.Modified = false;
                        richTextBox1.Clear();
                        return;
                    }
                    else
                    {
                        buttonItem1_Click(this, new EventArgs());
                        richTextBox1.Modified = false;
                        richTextBox1.Clear();
                        currentFile = "";
                        
                        return;
                    }
                }
                else
                {
                    currentFile = "";
                    richTextBox1.Modified = false;
                    richTextBox1.Clear();
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString(), "Error");
            }
        }

        private void buttonItem1_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(currentFileName))
            {
                saveFileDialog1.Filter = "Text File (.txt)|*.txt|All Files|*.*";
                saveFileDialog1.ShowDialog();
            }
            else
            {
                using (System.IO.StreamWriter sw = new System.IO.StreamWriter(currentFileName))
                {
                    sw.Write(richTextBox1.Text);
                }
            }
        }

        private void buttonItem31_Click(object sender, EventArgs e)
        {

        }

        private void btnBulletedList_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectionBullet = true;
        }

        private void buttonItem45_Click(object sender, EventArgs e)
        {

            openFileDialog1.Title = "RTE - Insert Image File";
            openFileDialog1.DefaultExt = "rtf";
            openFileDialog1.Filter = "Bitmap Files|*.bmp|JPEG Files|*.jpg|GIF Files|*.gif";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.ShowDialog();

            if (openFileDialog1.FileName == "")
            {
                return;
            }

            try
            {
                string strImagePath = openFileDialog1.FileName;
                Image img;
                img = Image.FromFile(strImagePath);
                Clipboard.SetDataObject(img);
                DataFormats.Format df;
                df = DataFormats.GetFormat(DataFormats.Bitmap);
                if (this.richTextBox1.CanPaste(df))
                {
                    this.richTextBox1.Paste(df);
                }
            }
            catch
            {
                MessageBox.Show("Unable to insert image format selected.", "RTE - Paste", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void colorPickerDropDown1_SelectedColorChanged(object sender, EventArgs e)
        {
            richTextBox1.SelectionColor = colorPickerDropDown1.SelectedColor;
        }

        private void colorPickerDropDown2_SelectedColorChanged(object sender, EventArgs e)
        {
            richTextBox1.SelectionBackColor = colorPickerDropDown2.SelectedColor;
        }

        private void colorPickerDropDown3_SelectedColorChanged(object sender, EventArgs e)
        {
            richTextBox1.BackColor = colorPickerDropDown3.SelectedColor;
        }

        private void buttonItem22_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectedText = richTextBox1.SelectedText.ToUpper();
        }

        private void buttonItem27_Click(object sender, EventArgs e)
        {
            richTextBox1.SelectedText = richTextBox1.SelectedText.ToLower();
        }

        private void timer1_Tick_1(object sender, EventArgs e)
        {
            if (richTextBox1.Text.Length > 0)
            {
                toolStripStatusLabel1.Text = richTextBox1.Text.Length.ToString();
            }
        }

        private void buttonItem34_Click(object sender, EventArgs e)
        {

        }

        private void buttonItem43_Click(object sender, EventArgs e)
        {
            Form FindReplaceDialog = new FindReplaceDialog();
            FindReplaceDialog.Show(this);
        }

        #region "Declaration"

        private string currentFile;
        private int checkPrint;

        #endregion

        #region Form Closing Handler

        private void Form1_closing(object sender, FormClosingEventArgs e)
               {
            try
            {
                if (richTextBox1.Modified == true)
                {
                    System.Windows.Forms.DialogResult answer;
        answer = MessageBox.Show("Save this document before closing?", "Unsaved Document", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (answer == System.Windows.Forms.DialogResult.Yes)
                    {
                        if (string.IsNullOrEmpty(currentFileName))
                        {
                            saveFileDialog1.Filter = "Text File (.txt)|*.txt|All Files|*.*";
                            saveFileDialog1.ShowDialog();
                        }
                        else
                        {
                            using (System.IO.StreamWriter sw = new System.IO.StreamWriter(currentFileName))
                            {
                                sw.Write(richTextBox1.Text);
                            }
                        }
                    }
                    else
                    {
                        richTextBox1.Modified = false;
                        Application.Exit();
                    }
                }
                else
                {
                   richTextBox1.Modified = false;
                    Application.Exit();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString(), "Error");
            }
        }
        #endregion
    }


}



