﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;



namespace Speak_To_Text_new_Style
{
    public partial class FindReplaceDialog : Form
    {
        Form1 mMain;
        

        public FindReplaceDialog()
        {
            InitializeComponent();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
        
        }

        private void FindReplaceDialog_Load(object sender, EventArgs e)
        {

        }

        private void FindCommand_Click(object sender, EventArgs e)
        {
            try
            {
                int StartPosition;
                StringComparison SearchType;

                if (CheckIgnoreCase.Checked == true)
                {
                    SearchType = StringComparison.Ordinal;
                }
                else
                {
                    SearchType = StringComparison.OrdinalIgnoreCase;
                }

                StartPosition = mMain.richTextBox1.Text.IndexOf(SearchTermText.Text, SearchType);

                if (StartPosition == 0)
                {
                    MessageBox.Show("String: " + SearchTermText.Text.ToString() + " not found", "No Matches", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                    return;
                }

                mMain.richTextBox1.Select(StartPosition, SearchTermText.Text.Length);
                mMain.richTextBox1.ScrollToCaret();
                mMain.Focus();

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString(), "Error");
            }

        }

        private void ReplaceCommand_Click(object sender, EventArgs e)
        {
            try
            {
                if (mMain.richTextBox1.SelectedText.Length != 0)
                {
                    mMain.richTextBox1.SelectedText = ReplaceText.Text;
                }

                int StartPosition;
                StringComparison SearchType;

                if (CheckIgnoreCase.Checked == true)
                {
                    SearchType = StringComparison.Ordinal;
                }
                else
                {
                    SearchType = StringComparison.OrdinalIgnoreCase;
                }

                StartPosition = mMain.richTextBox1.Text.IndexOf(ReplaceText.Text, SearchType);

                if (StartPosition == 0 || StartPosition < 0)
                {
                    MessageBox.Show("String: " + ReplaceText.Text.ToString() + " not found", "No Matches", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                    return;
                }

                mMain.richTextBox1.Select(StartPosition, ReplaceText.Text.Length);
                mMain.richTextBox1.ScrollToCaret();
                mMain.Focus();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString(), "Error");
            }
        }

        private void ReplaceAllCommand_Click(object sender, EventArgs e)
        {
            try
            {
                mMain.richTextBox1.Rtf = mMain.richTextBox1.Rtf.Replace(SearchTermText.Text.Trim(), ReplaceText.Text.Trim());


                int StartPosition;
                StringComparison SearchType;

                if (CheckIgnoreCase.Checked == true)
                {
                    SearchType = StringComparison.Ordinal;
                }
                else
                {
                    SearchType = StringComparison.OrdinalIgnoreCase;
                }

                StartPosition = mMain.richTextBox1.Text.IndexOf(ReplaceText.Text, SearchType);

                mMain.richTextBox1.Select(StartPosition, ReplaceText.Text.Length);
                mMain.richTextBox1.ScrollToCaret();
                mMain.Focus();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString(), "Error");
            }

        }

        private void CancelCommand_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void SearchTermText_TextChanged(object sender, EventArgs e)
        {

        }
    }
    }

